"{ Package: 'stx:libbasic3' }"

"{ NameSpace: Packages }"

TestCase subclass:#AbstractTestCases
	instanceVariableNames:''
	classVariableNames:'ClearUpFiles'
	poolDictionaries:''
	category:'Package-TestCases'
!

Notification subclass:#PackageTestCaseNotification
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	privateIn:AbstractTestCases
!

!AbstractTestCases class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
         (james@miraculix)

    [instance variables:]

    [class variables:]

    [see also:]

"
!

history
    "Created: / 30.1.2003 / 10:54:54 / james"
! !

!AbstractTestCases methodsFor:'factory'!

packageTestCaseNotification
    ^ PackageTestCaseNotification
! !

!AbstractTestCases methodsFor:'helpers'!

aDolphinTestFilePac
    ^ '~/AvatarChat.pac' asFilename.
!

assertSmalltalkIncludesAllClassNames:aCollectionOfSymbols 
    aCollectionOfSymbols do:[:aSymbol |
        self shouldnt:((Smalltalk at:aSymbol ifAbsent:[nil]) == nil).
    ].
!

assertSmalltalkIncludesAllLooseMethods:aCollectionOfLooseMethods

    aCollectionOfLooseMethods do:[:aPackagedMethod |   | class |
        class := (Smalltalk at:aPackagedMethod mclass name).
        self assert:(class methodDictionary keys includes:aPackagedMethod name).
    ].
!

createMethodFor:aClass source:aString
    aClass
        compile:aString
        classified:'aDummyClassification'
        notifying:nil.
!

createTestCaseDirectory
    "create the testcase directory if i"
    | testCaseDirectory |
    (testCaseDirectory := self testCaseDirectory) exists ifFalse:[
        testCaseDirectory makeDirectory.
    ].
!

createTestCaseFilenameFor:aFilenameOrString 
    ^ self testCaseDirectory filenameFor:aFilenameOrString asFilename
!

initializePackageManager
    PackageManager initialize.
!

packageManager
    ^ PackageManager smalltalkPackageManager
!

removeClassNamed:aSymbol 
    (Smalltalk at:aSymbol) ifNotNil:[
        ^ (Smalltalk at:aSymbol) removeFromSystem.
    ]
!

shouldntSmalltalkIncludesAllClassNames:aCollectionOfSymbols 
    aCollectionOfSymbols do:[:aSymbol |
        self assert:((Smalltalk at:aSymbol ifAbsent:[nil]) == nil).
    ].

!

shouldntSmalltalkIncludesAllLooseMethods:aCollectionOfLooseMethods

    aCollectionOfLooseMethods do:[:aMethod |  | class|
        class := (Smalltalk classNamed:aMethod className).
        "if class is nil then the test has also passed"
        class ifNotNil:[
            self shouldnt:(class methodDictionary keys includes:aMethod name).
        ].

    ].
!

testCaseDirectory
    ^ (Filename named:'~/work/stx/testCases/')
! !

!AbstractTestCases methodsFor:'initialize / release'!

setUp
    "common setup - invoked before testing"
    self initialize.
    super setUp
!

tearDown
    "common cleanup - invoked after testing"

    super tearDown
! !

!AbstractTestCases methodsFor:'instance creation'!

createClassNamed:aClassName 
    self createClassNamed:aClassName inheritsFrom:#Object
!

createClassNamed:aClassName inheritsFrom:anInheritingClassName
    ^ (Smalltalk at:anInheritingClassName) 
        subclass:aClassName
        instanceVariableNames:''
        classVariableNames:''
        poolDictionaries:''
        category:'AAAAA'
        classInstanceVariableNames:''
! !

!AbstractTestCases methodsFor:'queries'!

clearUpFiles
    ClearUpFiles ifNil:[
        ClearUpFiles := false.
    ].

    ^ ClearUpFiles
! !

!AbstractTestCases class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/packages/AbstractTestCases.st,v 1.2 2003-05-12 11:13:33 james Exp $'
! !
